/*
 * Copyright (c) 2000  Yoshihiro Takagi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __EBookApp_H
#define __EBookApp_H

#include <Application.h>

extern const char *app_signature;

class BMenuBar;
class EBookEngine;
class SettingsFile;

class EBBookApp : public BApplication {
public:
	EBBookApp();
	virtual ~EBBookApp();
	virtual void ReadyToRun();
	virtual void AboutRequested();
	virtual void MessageReceived(BMessage *);

private:
	BMenuBar *SetupMenuBar();
	EBookEngine *__engine;
	SettingsFile *__settings;
};

#endif	// __EBookApp_H
