/*
 * Copyright (c) 2000  Yoshihiro Takagi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __EBookView_H
#define __EBookView_H

#include <View.h>
#include "Observer.h"

class BTextControl;
class BPopUpMenu;
class BListView;
class EBookEngine;
class BMessage;

class _EXPORT EBookView : public BView, public Observer {
public:
	EBookView(EBookEngine *, BMessage *message, BRect frame, const char *name, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW);
	virtual ~EBookView();
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);

	EBookView(BMessage *data);
	static BArchivable *Instantiate(BMessage *data);
	virtual	status_t Archive(BMessage *data, bool deep = true) const;

	virtual void update(Observable *, void *);

private:
	void Load(BMessage *msg);
	void Save(BMessage *msg) const;
	void InitView();
	void EmptyListView();

	BTextControl *__text;
	BPopUpMenu   *__dictionary;
	BListView    *__listview;
	BTextView    *__content;
	EBookEngine  *__engine;
	BMessage     *__message;
	bool replicant;
};

#endif	// __EBookView_H
