/*
 * Copyright (c) 2000  Yoshihiro Takagi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __Observable_H
#define __Observable_H

#include <vector>

using namespace std;

class Observer;

class Observable {
public:
	Observable();
	void addObserver(Observer *o);
	void deleteObserver(const Observer *o);
	void notifyObservers(void *arg = 0);
	void deleteObservers();
	bool hasChanged() const;
	int  countObservers() const;

protected:
	void setChanged();
	void clearChanged();

private:
	bool changed;
	vector<Observer *> obs;
};

#endif	// __Observable_H
